Index: protocols/yahoo/libyahoo2.c
===================================================================
--- protocols/yahoo/libyahoo2.c	(revision c36f73bd317dd55d7e70275a6425faa4be7bfd8c)
+++ protocols/yahoo/libyahoo2.c	(revision 9034ba002b8945aee0f905b928bb0f60da9afe9f)
@@ -2540,7 +2008,8 @@
 	}
 
-	if (pkt->status == 0xffffffff) {
-		YAHOO_CALLBACK(ext_yahoo_login_response) (yd->client_id, login_status, url);
-	/*	yahoo_logoff(yd->client_id);*/
+	if (pkt->status == YPACKET_STATUS_DISCONNECTED) {
+		YAHOO_CALLBACK(ext_yahoo_login_response) (yd->client_id,
+			login_status, url);
+		/*      yahoo_logoff(yd->client_id); */
 	}
 }
@@ -2580,4 +2049,35 @@
 }
 
+static void yahoo_process_new_contact(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt)
+{
+	struct yahoo_data *yd = yid->yd;
+	char *me = NULL;
+	char *who = NULL;
+	char *msg = NULL;
+	int online = -1;
+
+	YList *l;
+
+	for (l = pkt->hash; l; l = l->next) {
+		struct yahoo_pair *pair = l->data;
+		if (pair->key == 4)
+			who = pair->value;
+		else if (pair->key == 5)
+			me = pair->value;
+		else if (pair->key == 14)
+			msg = pair->value;
+		else if (pair->key == 13)
+			online = strtol(pair->value, NULL, 10);
+	}
+
+	if (who && online < 0)
+		YAHOO_CALLBACK(ext_yahoo_contact_added) (yd->client_id, me, who,
+			msg);
+	else if (online == 2)
+		YAHOO_CALLBACK(ext_yahoo_rejected) (yd->client_id, who, msg);
+}
+
+/* UNUSED? */
 static void yahoo_process_contact(struct yahoo_input_data *yid,
 	struct yahoo_packet *pkt)
@@ -2661,39 +2161,19 @@
 		where = "Unknown";
 
-	/* status: 0 == Successful, 1 == Error (does not exist), 2 == Already in list */
-	if ( status == 0 ) {
-		bud = y_new0(struct yahoo_buddy, 1);
-		bud->id = strdup(who);
-		bud->group = strdup(where);
-		bud->real_name = NULL;
-		
-		yd->buddies = y_list_append(yd->buddies, bud);
-	
-		/* Possibly called already, but at least the call above doesn't
-		   seem to happen every time (not anytime I tried). */
-		YAHOO_CALLBACK(ext_yahoo_contact_added) (yd->client_id, me, who, NULL);
-	}
-
-/*	YAHOO_CALLBACK(ext_yahoo_status_changed) (yd->client_id, who, status, NULL, (status==YAHOO_STATUS_AVAILABLE?0:1)); */
-}
-
-static void yahoo_process_contact_ymsg13(struct yahoo_input_data *yid, struct yahoo_packet *pkt)
-{
-	char* who = NULL;
-	char* me = NULL;	
-	char* msg = NULL;
-	YList *l;
-	for (l = pkt->hash; l; l = l->next) {
-		struct yahoo_pair *pair = l->data;
-		if (pair->key == 4)
-			who = pair->value;
-		else if (pair->key == 5)
-			me = pair->value;
-		else
-			DEBUG_MSG(("unknown key: %d = %s", pair->key, pair->value));
-	}
-
-	if (pkt->status==3)
-		YAHOO_CALLBACK(ext_yahoo_contact_auth_request) (yid->yd->client_id, me, who, msg);
+	bud = y_new0(struct yahoo_buddy, 1);
+	bud->id = strdup(who);
+	bud->group = strdup(where);
+	bud->real_name = NULL;
+
+	yd->buddies = y_list_append(yd->buddies, bud);
+
+	/* A non-zero status (i've seen 2) seems to mean the buddy is already 
+	 * added and is online */
+	if (status) {
+		LOG(("Setting online see packet for info"));
+		yahoo_dump_unhandled(pkt);
+		YAHOO_CALLBACK(ext_yahoo_status_changed) (yd->client_id, who,
+			YAHOO_STATUS_AVAILABLE, NULL, 0, 0, 0);
+	}
 }
 
@@ -2783,5 +2263,5 @@
 
 /*	if(status)
-		YAHOO_CALLBACK(ext_yahoo_error) (yd->client_id, who, 0, status);
+		YAHOO_CALLBACK(ext_yahoo_error)(yd->client_id, who, 0, status);
 */
 }
@@ -2837,5 +2317,30 @@
 }
 
-static void _yahoo_webcam_get_server_connected(int fd, int error, void *d)
+static void yahoo_process_buddy_change_group(struct yahoo_input_data *yid,
+	struct yahoo_packet *pkt)
+{
+	YList *l;
+	char *me = NULL;
+	char *who = NULL;
+	char *old_group = NULL;
+	char *new_group = NULL;
+
+	for (l = pkt->hash; l; l = l->next) {
+		struct yahoo_pair *pair = l->data;
+		if (pair->key == 1)
+			me = pair->value;
+		if (pair->key == 7)
+			who = pair->value;
+		if (pair->key == 224)
+			old_group = pair->value;
+		if (pair->key == 264)
+			new_group = pair->value;
+	}
+
+	YAHOO_CALLBACK(ext_yahoo_got_buddy_change_group) (yid->yd->client_id,
+		me, who, old_group, new_group);
+}
+
+static void _yahoo_webcam_get_server_connected(void *fd, int error, void *d)
 {
 	struct yahoo_input_data *yid = d;
@@ -2848,5 +2353,5 @@
 	unsigned int pos = 0;
 
-	if (error || fd <= 0) {
+	if (error || !fd) {
 		FREE(who);
 		FREE(yid);
@@ -2905,5 +2410,5 @@
 	YAHOO_CALLBACK(ext_yahoo_connect_async) (yid->yd->client_id,
 		yss->webcam_host, yss->webcam_port,
-		_yahoo_webcam_get_server_connected, yid);
+		_yahoo_webcam_get_server_connected, yid, 0);
 
 }
@@ -2952,5 +2457,5 @@
 	case YAHOO_SERVICE_IDDEACT:
 	case YAHOO_SERVICE_Y6_STATUS_UPDATE:
-	case YAHOO_SERVICE_YMSG15_STATUS:
+	case YAHOO_SERVICE_Y8_STATUS:
 		yahoo_process_status(yid, pkt);
 		break;
@@ -2966,5 +2471,7 @@
 		yahoo_process_mail(yid, pkt);
 		break;
-	case YAHOO_SERVICE_REJECTCONTACT:
+	case YAHOO_SERVICE_Y7_AUTHORIZATION:
+		yahoo_process_new_contact(yid, pkt);
+		break;
 	case YAHOO_SERVICE_NEWCONTACT:
 		yahoo_process_contact(yid, pkt);
@@ -3001,12 +2508,15 @@
 		break;
 	case YAHOO_SERVICE_P2PFILEXFER:
-	case YAHOO_SERVICE_FILETRANSFER:
+	case YAHOO_SERVICE_Y7_FILETRANSFER:
 		yahoo_process_filetransfer(yid, pkt);
+		break;
+	case YAHOO_SERVICE_Y7_FILETRANSFERINFO:
+		yahoo_process_filetransferinfo(yid, pkt);
+		break;
+	case YAHOO_SERVICE_Y7_FILETRANSFERACCEPT:
+		yahoo_process_filetransferaccept(yid, pkt);
 		break;
 	case YAHOO_SERVICE_ADDBUDDY:
 		yahoo_process_buddyadd(yid, pkt);
-		break;
-	case YAHOO_SERVICE_CONTACT_YMSG13:
-		yahoo_process_contact_ymsg13(yid,pkt);
 		break;
 	case YAHOO_SERVICE_REMBUDDY:
@@ -3025,4 +2535,7 @@
 		yahoo_process_ping(yid, pkt);
 		break;
+	case YAHOO_SERVICE_Y7_CHANGE_GROUP:
+		yahoo_process_buddy_change_group(yid, pkt);
+		break;
 	case YAHOO_SERVICE_IDLE:
 	case YAHOO_SERVICE_MAILSTAT:
@@ -3038,4 +2551,5 @@
 	case YAHOO_SERVICE_CHATLOGOFF:
 	case YAHOO_SERVICE_CHATMSG:
+	case YAHOO_SERVICE_REJECTCONTACT:
 	case YAHOO_SERVICE_PEERTOPEER:
 		WARNING(("unhandled service 0x%02x", pkt->service));
@@ -3050,7 +2564,8 @@
 	case YAHOO_SERVICE_PICTURE_UPLOAD:
 		yahoo_process_picture_upload(yid, pkt);
-		break;	
-	case YAHOO_SERVICE_YMSG15_BUDDY_LIST:	/* Buddy List */
+		break;
+	case YAHOO_SERVICE_Y8_LIST:	/* Buddy List */
 		yahoo_process_buddy_list(yid, pkt);
+		break;
 	default:
 		WARNING(("unknown service 0x%02x", pkt->service));
@@ -3387,78 +2902,79 @@
 
 	/* find out what kind of packet we got */
-	switch (yid->wcd->packet_type)
-	{
-		case 0x00:
-			/* user requests to view webcam (uploading) */
-			if (yid->wcd->data_size &&
-				yid->wcm->direction == YAHOO_WEBCAM_UPLOAD) {
-				end = begin;
-				while (end <= yid->rxlen &&
-					yid->rxqueue[end++] != 13);
-				if (end > begin)
-				{
-					who = y_memdup(yid->rxqueue + begin, end - begin);
-					who[end - begin - 1] = 0;
-					YAHOO_CALLBACK(ext_yahoo_webcam_viewer) (yd->client_id, who + 2, 2);
-					FREE(who);
-				}
-			}
-
-			if (yid->wcm->direction == YAHOO_WEBCAM_DOWNLOAD) {
-				/* timestamp/status field */
-				/* 0 = declined viewing permission */
-				/* 1 = accepted viewing permission */
-				if (yid->wcd->timestamp == 0) {
-					YAHOO_CALLBACK(ext_yahoo_webcam_closed) (yd->client_id, yid->wcm->user, 3);
-				}
-			}
-			break;
-		case 0x01: /* status packets?? */
-			/* timestamp contains status info */
-			/* 00 00 00 01 = we have data?? */
-			break;
-		case 0x02: /* image data */
-			YAHOO_CALLBACK(ext_yahoo_got_webcam_image) (yd->client_id, 
-					yid->wcm->user, yid->rxqueue + begin,
-					yid->wcd->data_size, pos - begin,
-					yid->wcd->timestamp);
-			break;
-		case 0x05: /* response packets when uploading */
-			if (!yid->wcd->data_size) {
-				YAHOO_CALLBACK(ext_yahoo_webcam_data_request) (yd->client_id, yid->wcd->timestamp);
-			}
-			break;
-		case 0x07: /* connection is closing */
-			switch(reason)
-			{
-				case 0x01: /* user closed connection */
-					closed = 1;
-					break;
-				case 0x0F: /* user cancelled permission */
-					closed = 2;
-					break;
-			}
-			YAHOO_CALLBACK(ext_yahoo_webcam_closed) (yd->client_id, yid->wcm->user, closed);
-			break;
-		case 0x0C: /* user connected */
-		case 0x0D: /* user disconnected */
-			if (yid->wcd->data_size) {
-				who = y_memdup(yid->rxqueue + begin, pos - begin + 1);
-				who[pos - begin] = 0;
-				if (yid->wcd->packet_type == 0x0C)
-					connect = 1;
-				else
-					connect = 0;
-				YAHOO_CALLBACK(ext_yahoo_webcam_viewer) (yd->client_id, who, connect);
+	switch (yid->wcd->packet_type) {
+	case 0x00:
+		/* user requests to view webcam (uploading) */
+		if (yid->wcd->data_size &&
+			yid->wcm->direction == YAHOO_WEBCAM_UPLOAD) {
+			end = begin;
+			while (end <= yid->rxlen && yid->rxqueue[end++] != 13) ;
+			if (end > begin) {
+				who = y_memdup(yid->rxqueue + begin,
+					end - begin);
+				who[end - begin - 1] = 0;
+				YAHOO_CALLBACK(ext_yahoo_webcam_viewer) (yd->
+					client_id, who + 2, 2);
 				FREE(who);
 			}
-			break;
-		case 0x13: /* user data */
-			/* i = user_ip (ip of the user we are viewing) */
-			/* j = user_ext_ip (external ip of the user we */
- 			/*                are viewing) */
-			break;
-		case 0x17: /* ?? */
-			break;
+		}
+
+		if (yid->wcm->direction == YAHOO_WEBCAM_DOWNLOAD) {
+			/* timestamp/status field */
+			/* 0 = declined viewing permission */
+			/* 1 = accepted viewing permission */
+			if (yid->wcd->timestamp == 0) {
+				YAHOO_CALLBACK(ext_yahoo_webcam_closed) (yd->
+					client_id, yid->wcm->user, 3);
+			}
+		}
+		break;
+	case 0x01:		/* status packets?? */
+		/* timestamp contains status info */
+		/* 00 00 00 01 = we have data?? */
+		break;
+	case 0x02:		/* image data */
+		YAHOO_CALLBACK(ext_yahoo_got_webcam_image) (yd->client_id,
+			yid->wcm->user, yid->rxqueue + begin,
+			yid->wcd->data_size, pos - begin, yid->wcd->timestamp);
+		break;
+	case 0x05:		/* response packets when uploading */
+		if (!yid->wcd->data_size) {
+			YAHOO_CALLBACK(ext_yahoo_webcam_data_request) (yd->
+				client_id, yid->wcd->timestamp);
+		}
+		break;
+	case 0x07:		/* connection is closing */
+		switch (reason) {
+		case 0x01:	/* user closed connection */
+			closed = 1;
+			break;
+		case 0x0F:	/* user cancelled permission */
+			closed = 2;
+			break;
+		}
+		YAHOO_CALLBACK(ext_yahoo_webcam_closed) (yd->client_id,
+			yid->wcm->user, closed);
+		break;
+	case 0x0C:		/* user connected */
+	case 0x0D:		/* user disconnected */
+		if (yid->wcd->data_size) {
+			who = y_memdup(yid->rxqueue + begin, pos - begin + 1);
+			who[pos - begin] = 0;
+			if (yid->wcd->packet_type == 0x0C)
+				connect = 1;
+			else
+				connect = 0;
+			YAHOO_CALLBACK(ext_yahoo_webcam_viewer) (yd->client_id,
+				who, connect);
+			FREE(who);
+		}
+		break;
+	case 0x13:		/* user data */
+		/* i=user_ip (ip of the user we are viewing) */
+		/* j=user_ext_ip (external ip of the user we */
+		/*                are viewing) */
+		break;
+	case 0x17:		/* ?? */
+		break;
 	}
 	yid->wcd->to_read -= pos - begin;
@@ -3466,9 +2982,10 @@
 	yid->rxlen -= pos;
 	DEBUG_MSG(("rxlen == %d, rxqueue == %p", yid->rxlen, yid->rxqueue));
-	if (yid->rxlen>0) {
+	if (yid->rxlen > 0) {
 		unsigned char *tmp = y_memdup(yid->rxqueue + pos, yid->rxlen);
 		FREE(yid->rxqueue);
 		yid->rxqueue = tmp;
-		DEBUG_MSG(("new rxlen == %d, rxqueue == %p", yid->rxlen, yid->rxqueue));
+		DEBUG_MSG(("new rxlen == %d, rxqueue == %p", yid->rxlen,
+				yid->rxqueue));
 	} else {
 		DEBUG_MSG(("freed rxqueue == %p", yid->rxqueue));
@@ -3483,5 +3000,5 @@
 }
 
-int yahoo_write_ready(int id, int fd, void *data)
+int yahoo_write_ready(int id, void *fd, void *data)
 {
 	struct yahoo_input_data *yid = data;
@@ -3489,8 +3006,8 @@
 	struct data_queue *tx;
 
-	LOG(("write callback: id=%d fd=%d data=%p", id, fd, data));
-	if (!yid || !yid->txqueues || !find_conn_by_id(id))
+	LOG(("write callback: id=%d fd=%p data=%p", id, fd, data));
+	if (!yid || !yid->txqueues)
 		return -2;
-	
+
 	tx = yid->txqueues->data;
 	LOG(("writing %d bytes", tx->len));
@@ -3508,8 +3025,10 @@
 			free(tx->queue);
 			free(tx);
-			yid->txqueues = y_list_remove_link(yid->txqueues, yid->txqueues);
+			yid->txqueues =
+				y_list_remove_link(yid->txqueues,
+				yid->txqueues);
 			y_list_free_1(l);
 		}
-		LOG(("yahoo_write_ready(%d, %d) len < 0", id, fd));
+		LOG(("yahoo_write_ready(%d, %p) len < 0", id, fd));
 		YAHOO_CALLBACK(ext_yahoo_remove_handler) (id, yid->write_tag);
 		yid->write_tag = 0;
@@ -3528,13 +3047,15 @@
 		free(tx->queue);
 		free(tx);
-		yid->txqueues = y_list_remove_link(yid->txqueues, yid->txqueues);
+		yid->txqueues =
+			y_list_remove_link(yid->txqueues, yid->txqueues);
 		y_list_free_1(l);
 		/*
-		if (!yid->txqueues) 
-			LOG(("yahoo_write_ready(%d, %d) !yxqueues", id, fd));
-		*/
+		   if(!yid->txqueues) 
+		   LOG(("yahoo_write_ready(%d, %d) !yxqueues", id, fd));
+		 */
 		if (!yid->txqueues) {
-			LOG(("yahoo_write_ready(%d, %d) !yxqueues", id, fd));
-			YAHOO_CALLBACK(ext_yahoo_remove_handler) (id, yid->write_tag);
+			LOG(("yahoo_write_ready(%d, %p) !txqueues", id, fd));
+			YAHOO_CALLBACK(ext_yahoo_remove_handler) (id,
+				yid->write_tag);
 			yid->write_tag = 0;
 		}
@@ -3544,5 +3065,6 @@
 }
 
-static void yahoo_process_pager_connection(struct yahoo_input_data *yid, int over)
+static void yahoo_process_pager_connection(struct yahoo_input_data *yid,
+	int over)
 {
 	struct yahoo_packet *pkt;
@@ -3553,6 +3075,6 @@
 		return;
 
-	while (find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER) 
-			&& (pkt = yahoo_getdata(yid)) != NULL) {
+	while (find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER)
+		&& (pkt = yahoo_getdata(yid)) != NULL) {
 
 		yahoo_packet_process(yid, pkt);
@@ -3562,15 +3084,13 @@
 }
 
-static void yahoo_process_ft_connection(struct yahoo_input_data *yid, int over)
-{
-}
-
-static void yahoo_process_chatcat_connection(struct yahoo_input_data *yid, int over)
+static void yahoo_process_chatcat_connection(struct yahoo_input_data *yid,
+	int over)
 {
 	if (over)
 		return;
 
-	if (strstr((char*)yid->rxqueue+(yid->rxlen-20), "</content>")) {
-		YAHOO_CALLBACK(ext_yahoo_chat_cat_xml) (yid->yd->client_id, (char*)yid->rxqueue);
+	if (strstr((char *)yid->rxqueue + (yid->rxlen - 20), "</content>")) {
+		YAHOO_CALLBACK(ext_yahoo_chat_cat_xml) (yid->yd->client_id,
+			(char *)yid->rxqueue);
 	}
 }
@@ -3583,46 +3103,68 @@
 	int changed = 0;
 	int id = yd->client_id;
+	int yab_used = 0;
+
+	LOG(("Got data for YAB"));
 
 	if (over)
 		return;
 
-	while (find_input_by_id_and_type(id, YAHOO_CONNECTION_YAB) 
-			&& (yab = yahoo_getyab(yid)) != NULL) {
+	while (find_input_by_id_and_type(id, YAHOO_CONNECTION_YAB)
+		&& (yab = yahoo_getyab(yid)) != NULL) {
 		if (!yab->id)
 			continue;
+
 		changed = 1;
+		yab_used = 0;
 		for (buds = yd->buddies; buds; buds = buds->next) {
 			struct yahoo_buddy *bud = buds->data;
 			if (!strcmp(bud->id, yab->id)) {
+				yab_used = 1;
 				bud->yab_entry = yab;
 				if (yab->nname) {
 					bud->real_name = strdup(yab->nname);
 				} else if (yab->fname && yab->lname) {
-					bud->real_name = y_new0(char, 
-							strlen(yab->fname)+
-							strlen(yab->lname)+2
-							);
+					bud->real_name = y_new0(char,
+						strlen(yab->fname) +
+						strlen(yab->lname) + 2);
 					sprintf(bud->real_name, "%s %s",
-							yab->fname, yab->lname);
+						yab->fname, yab->lname);
 				} else if (yab->fname) {
 					bud->real_name = strdup(yab->fname);
 				}
-				break; /* for */
+				break;	/* for */
 			}
 		}
+
+		if (!yab_used) {
+			FREE(yab->fname);
+			FREE(yab->lname);
+			FREE(yab->nname);
+			FREE(yab->id);
+			FREE(yab->email);
+			FREE(yab->hphone);
+			FREE(yab->wphone);
+			FREE(yab->mphone);
+			FREE(yab);
+		}
+
 	}
 
 	if (changed)
-		YAHOO_CALLBACK(ext_yahoo_got_buddies) (yd->client_id, yd->buddies);
-}
-
-static void yahoo_process_search_connection(struct yahoo_input_data *yid, int over)
+		YAHOO_CALLBACK(ext_yahoo_got_buddies) (yd->client_id,
+			yd->buddies);
+}
+
+static void yahoo_process_search_connection(struct yahoo_input_data *yid,
+	int over)
 {
 	struct yahoo_found_contact *yct = NULL;
 	char *p = (char *)yid->rxqueue, *np, *cp;
 	int k, n;
-	int start = 0, found=0, total=0;
+	int start = 0, found = 0, total = 0;
 	YList *contacts = NULL;
-	struct yahoo_input_data *pyid = find_input_by_id_and_type(yid->yd->client_id, YAHOO_CONNECTION_PAGER);
+	struct yahoo_input_data *pyid =
+		find_input_by_id_and_type(yid->yd->client_id,
+		YAHOO_CONNECTION_PAGER);
 
 	if (!over || !pyid)
@@ -3635,8 +3177,14 @@
 			p++;
 			n = atoi(p);
-			switch(k) {
-				case 0: found = pyid->ys->lsearch_nfound = n; break;
-				case 2: start = pyid->ys->lsearch_nstart = n; break;
-				case 3: total = pyid->ys->lsearch_ntotal = n; break;
+			switch (k) {
+			case 0:
+				found = pyid->ys->lsearch_nfound = n;
+				break;
+			case 2:
+				start = pyid->ys->lsearch_nstart = n;
+				break;
+			case 3:
+				total = pyid->ys->lsearch_ntotal = n;
+				break;
 			}
 		}
@@ -3653,35 +3201,39 @@
 				break;
 			*np = 0;
-			p = np+1;
-
-			switch(k++) {
-				case 1:
-					if (strlen(cp) > 2 && y_list_length(contacts) < total) {
-						yct = y_new0(struct yahoo_found_contact, 1);
-						contacts = y_list_append(contacts, yct);
-						yct->id = cp+2;
-					} else {
-						*p = 0;
-					}
-					break;
-				case 2: 
-					yct->online = !strcmp(cp, "2") ? 1 : 0;
-					break;
-				case 3: 
-					yct->gender = cp;
-					break;
-				case 4: 
-					yct->age = atoi(cp);
-					break;
-				case 5: 
-					if (strcmp(cp, "5") != 0)
-						yct->location = cp;
-					k = 0;
-					break;
+			p = np + 1;
+
+			switch (k++) {
+			case 1:
+				if (strlen(cp) > 2
+					&& y_list_length(contacts) < total) {
+					yct = y_new0(struct yahoo_found_contact,
+						1);
+					contacts = y_list_append(contacts, yct);
+					yct->id = cp + 2;
+				} else {
+					*p = 0;
+				}
+				break;
+			case 2:
+				yct->online = !strcmp(cp, "2") ? 1 : 0;
+				break;
+			case 3:
+				yct->gender = cp;
+				break;
+			case 4:
+				yct->age = atoi(cp);
+				break;
+			case 5:
+				/* not worth the context switch for strcmp */
+				if (cp[0] != '\005' || cp[1] != '\000')
+					yct->location = cp;
+				k = 0;
+				break;
 			}
 		}
 	}
 
-	YAHOO_CALLBACK(ext_yahoo_got_search_result) (yid->yd->client_id, found, start, total, contacts);
+	YAHOO_CALLBACK(ext_yahoo_got_search_result) (yid->yd->client_id, found,
+		start, total, contacts);
 
 	while (contacts) {
@@ -3693,5 +3245,5 @@
 }
 
-static void _yahoo_webcam_connected(int fd, int error, void *d)
+static void _yahoo_webcam_connected(void *fd, int error, void *d)
 {
 	struct yahoo_input_data *yid = d;
@@ -3701,10 +3253,10 @@
 	char *data = NULL;
 	char *packet = NULL;
-	unsigned char magic_nr[] = {1, 0, 0, 0, 1};
+	unsigned char magic_nr[] = { 1, 0, 0, 0, 1 };
 	unsigned header_len = 0;
 	unsigned int len = 0;
 	unsigned int pos = 0;
 
-	if (error || fd <= 0) {
+	if (error || !fd) {
 		FREE(yid);
 		return;
@@ -3716,14 +3268,13 @@
 	LOG(("Connected"));
 	/* send initial packet */
-	switch (wcm->direction)
-	{
-		case YAHOO_WEBCAM_DOWNLOAD:
-			data = strdup("<REQIMG>");
-			break;
-		case YAHOO_WEBCAM_UPLOAD:	
-			data = strdup("<SNDIMG>");
-			break;
-		default:
-			return;
+	switch (wcm->direction) {
+	case YAHOO_WEBCAM_DOWNLOAD:
+		data = strdup("<REQIMG>");
+		break;
+	case YAHOO_WEBCAM_UPLOAD:
+		data = strdup("<SNDIMG>");
+		break;
+	default:
+		return;
 	}
 	yahoo_add_to_send_queue(yid, data, strlen(data));
@@ -3731,36 +3282,35 @@
 
 	/* send data */
-	switch (wcm->direction)
-	{
-		case YAHOO_WEBCAM_DOWNLOAD:
-			header_len = 8;
-			data = strdup("a=2\r\nc=us\r\ne=21\r\nu=");
-			data = y_string_append(data, yd->user);
-			data = y_string_append(data, "\r\nt=");
-			data = y_string_append(data, wcm->key);
-			data = y_string_append(data, "\r\ni=");
-			data = y_string_append(data, wcm->my_ip);
-			data = y_string_append(data, "\r\ng=");
-			data = y_string_append(data, wcm->user);
-			data = y_string_append(data, "\r\no=w-2-5-1\r\np=");
-			snprintf(conn_type, sizeof(conn_type), "%d", wcm->conn_type);
-			data = y_string_append(data, conn_type);
-			data = y_string_append(data, "\r\n");
-			break;
-		case YAHOO_WEBCAM_UPLOAD:
-			header_len = 13;
-			data = strdup("a=2\r\nc=us\r\nu=");
-			data = y_string_append(data, yd->user);
-			data = y_string_append(data, "\r\nt=");
-			data = y_string_append(data, wcm->key);
-			data = y_string_append(data, "\r\ni=");
-			data = y_string_append(data, wcm->my_ip);
-			data = y_string_append(data, "\r\no=w-2-5-1\r\np=");
-			snprintf(conn_type, sizeof(conn_type), "%d", wcm->conn_type);
-			data = y_string_append(data, conn_type);
-			data = y_string_append(data, "\r\nb=");
-			data = y_string_append(data, wcm->description);
-			data = y_string_append(data, "\r\n");
-			break;
+	switch (wcm->direction) {
+	case YAHOO_WEBCAM_DOWNLOAD:
+		header_len = 8;
+		data = strdup("a=2\r\nc=us\r\ne=21\r\nu=");
+		data = y_string_append(data, yd->user);
+		data = y_string_append(data, "\r\nt=");
+		data = y_string_append(data, wcm->key);
+		data = y_string_append(data, "\r\ni=");
+		data = y_string_append(data, wcm->my_ip);
+		data = y_string_append(data, "\r\ng=");
+		data = y_string_append(data, wcm->user);
+		data = y_string_append(data, "\r\no=w-2-5-1\r\np=");
+		snprintf(conn_type, sizeof(conn_type), "%d", wcm->conn_type);
+		data = y_string_append(data, conn_type);
+		data = y_string_append(data, "\r\n");
+		break;
+	case YAHOO_WEBCAM_UPLOAD:
+		header_len = 13;
+		data = strdup("a=2\r\nc=us\r\nu=");
+		data = y_string_append(data, yd->user);
+		data = y_string_append(data, "\r\nt=");
+		data = y_string_append(data, wcm->key);
+		data = y_string_append(data, "\r\ni=");
+		data = y_string_append(data, wcm->my_ip);
+		data = y_string_append(data, "\r\no=w-2-5-1\r\np=");
+		snprintf(conn_type, sizeof(conn_type), "%d", wcm->conn_type);
+		data = y_string_append(data, conn_type);
+		data = y_string_append(data, "\r\nb=");
+		data = y_string_append(data, wcm->description);
+		data = y_string_append(data, "\r\n");
+		break;
 	}
 
@@ -3769,19 +3319,17 @@
 	packet[pos++] = header_len;
 	packet[pos++] = 0;
-	switch (wcm->direction)
-	{
-		case YAHOO_WEBCAM_DOWNLOAD:
-			packet[pos++] = 1;
-			packet[pos++] = 0;
-			break;
-		case YAHOO_WEBCAM_UPLOAD:
-			packet[pos++] = 5;
-			packet[pos++] = 0;
-			break;
+	switch (wcm->direction) {
+	case YAHOO_WEBCAM_DOWNLOAD:
+		packet[pos++] = 1;
+		packet[pos++] = 0;
+		break;
+	case YAHOO_WEBCAM_UPLOAD:
+		packet[pos++] = 5;
+		packet[pos++] = 0;
+		break;
 	}
 
 	pos += yahoo_put32(packet + pos, len);
-	if (wcm->direction == YAHOO_WEBCAM_UPLOAD)
-	{
+	if (wcm->direction == YAHOO_WEBCAM_UPLOAD) {
 		memcpy(packet + pos, magic_nr, sizeof(magic_nr));
 		pos += sizeof(magic_nr);
@@ -3792,5 +3340,7 @@
 	FREE(data);
 
-	yid->read_tag = YAHOO_CALLBACK(ext_yahoo_add_handler) (yid->yd->client_id, yid->fd, YAHOO_INPUT_READ, yid);
+	yid->read_tag =
+		YAHOO_CALLBACK(ext_yahoo_add_handler) (yid->yd->client_id,
+		yid->fd, YAHOO_INPUT_READ, yid);
 }
 
@@ -3817,12 +3367,13 @@
 
 	LOG(("Connecting to: %s:%d", wcm->server, wcm->port));
-	YAHOO_CALLBACK(ext_yahoo_connect_async) (y->yd->client_id, wcm->server, wcm->port,
-			_yahoo_webcam_connected, yid);
-
-}
-
-static void yahoo_process_webcam_master_connection(struct yahoo_input_data *yid, int over)
-{
-	char* server;
+	YAHOO_CALLBACK(ext_yahoo_connect_async) (y->yd->client_id, wcm->server,
+		wcm->port, _yahoo_webcam_connected, yid, 0);
+
+}
+
+static void yahoo_process_webcam_master_connection(struct yahoo_input_data *yid,
+	int over)
+{
+	char *server;
 	struct yahoo_server_settings *yss;
 
@@ -3832,6 +3383,5 @@
 	server = yahoo_getwebcam_master(yid);
 
-	if (server)
-	{
+	if (server) {
 		yss = yid->yd->server_settings;
 		yid->wcm->server = strdup(server);
@@ -3846,8 +3396,9 @@
 }
 
-static void yahoo_process_webcam_connection(struct yahoo_input_data *yid, int over)
+static void yahoo_process_webcam_connection(struct yahoo_input_data *yid,
+	int over)
 {
 	int id = yid->yd->client_id;
-	int fd = yid->fd;
+	void *fd = yid->fd;
 
 	if (over)
@@ -3855,19 +3406,18 @@
 
 	/* as long as we still have packets available keep processing them */
-	while (find_input_by_id_and_fd(id, fd) 
-			&& yahoo_get_webcam_data(yid) == 1);
-}
-
-static void (*yahoo_process_connection[])(struct yahoo_input_data *, int over) = {
-	yahoo_process_pager_connection,
-	yahoo_process_ft_connection,
-	yahoo_process_yab_connection,
-	yahoo_process_webcam_master_connection,
-	yahoo_process_webcam_connection,
-	yahoo_process_chatcat_connection,
-	yahoo_process_search_connection,
-};
-
-int yahoo_read_ready(int id, int fd, void *data)
+	while (find_input_by_id_and_fd(id, fd)
+		&& yahoo_get_webcam_data(yid) == 1) ;
+}
+
+static void (*yahoo_process_connection[]) (struct yahoo_input_data *,
+	int over) = {
+yahoo_process_pager_connection, yahoo_process_ft_connection,
+		yahoo_process_yab_connection,
+		yahoo_process_webcam_master_connection,
+		yahoo_process_webcam_connection,
+		yahoo_process_chatcat_connection,
+		yahoo_process_search_connection};
+
+int yahoo_read_ready(int id, void *fd, void *data)
 {
 	struct yahoo_input_data *yid = data;
@@ -3875,14 +3425,13 @@
 	int len;
 
-	LOG(("read callback: id=%d fd=%d data=%p", id, fd, data));
+	LOG(("read callback: id=%d fd=%p data=%p", id, fd, data));
 	if (!yid)
 		return -2;
 
-	
 	do {
-		len = read(fd, buf, sizeof(buf));
+		len = YAHOO_CALLBACK(ext_yahoo_read) (fd, buf, sizeof(buf));
 	} while (len == -1 && errno == EINTR);
 
-	if (len == -1 && (errno == EAGAIN||errno == EINTR))	/* we'll try again later */
+	if (len == -1 && (errno == EAGAIN || errno == EINTR))	/* we'll try again later */
 		return 1;
 
@@ -3892,8 +3441,9 @@
 
 		if (yid->type == YAHOO_CONNECTION_PAGER) {
-			YAHOO_CALLBACK(ext_yahoo_error) (yid->yd->client_id, "Connection closed by server", 1, E_CONNECTION);
-		}
-
-		yahoo_process_connection[yid->type](yid, 1);
+			YAHOO_CALLBACK(ext_yahoo_login_response) (yid->yd->
+				client_id, YAHOO_LOGIN_SOCK, NULL);
+		}
+
+		yahoo_process_connection[yid->type] (yid, 1);
 		yahoo_input_close(yid);
 
@@ -3907,9 +3457,11 @@
 	}
 
-	yid->rxqueue = y_renew(unsigned char, yid->rxqueue, len + yid->rxlen);
+	yid->rxqueue =
+		y_renew(unsigned char, yid->rxqueue, len + yid->rxlen + 1);
 	memcpy(yid->rxqueue + yid->rxlen, buf, len);
 	yid->rxlen += len;
-
-	yahoo_process_connection[yid->type](yid, 0);
+	yid->rxqueue[yid->rxlen] = 0;
+
+	yahoo_process_connection[yid->type] (yid, 0);
 
 	return len;
@@ -3948,11 +3500,5 @@
 }
 
-struct connect_callback_data {
-	struct yahoo_data *yd;
-	int tag;
-	int i;
-};
-
-static void yahoo_connected(int fd, int error, void *data)
+static void yahoo_connected(void *fd, int error, void *data)
 {
 	struct connect_callback_data *ccd = data;
@@ -3963,15 +3509,34 @@
 
 	if (error) {
+		int tag;
 		if (fallback_ports[ccd->i]) {
-			int tag;
+			char *host = yss->pager_host;
+
+			if (!host)
+				host = yss->pager_host_list[ccd->server_i];
+
 			yss->pager_port = fallback_ports[ccd->i++];
-			tag = YAHOO_CALLBACK(ext_yahoo_connect_async) (yd->client_id, yss->pager_host,
-					yss->pager_port, yahoo_connected, ccd);
+			tag = YAHOO_CALLBACK(ext_yahoo_connect_async) (yd->
+				client_id, host, yss->pager_port,
+				yahoo_connected, ccd, 0);
 
 			if (tag > 0)
 				ccd->tag = tag;
+		} else if (yss->pager_host_list
+				&& yss->pager_host_list[ccd->server_i]) {
+
+			/* Get back to the default port */
+			yss->pager_port = pager_port;
+			ccd->server_i++;
+			LOG(("Fallback: Connecting to %s:%d", yss->pager_host_list[ccd->server_i], yss->pager_port));
+
+			ccd->i = 0;
+			tag = YAHOO_CALLBACK(ext_yahoo_connect_async) (yd->client_id,
+				yss->pager_host_list[ccd->server_i], yss->pager_port,
+				yahoo_connected, ccd, 0);
 		} else {
 			FREE(ccd);
-			YAHOO_CALLBACK(ext_yahoo_login_response) (yd->client_id, YAHOO_LOGIN_SOCK, NULL);
+			YAHOO_CALLBACK(ext_yahoo_login_response) (yd->client_id,
+				YAHOO_LOGIN_SOCK, NULL);
 		}
 		return;
@@ -3980,17 +3545,16 @@
 	FREE(ccd);
 
-	/* fd < 0 && error == 0 means connect was cancelled */
-	if (fd < 0)
-		return;
-
-	pkt = yahoo_packet_new(YAHOO_SERVICE_AUTH, YAHOO_STATUS_AVAILABLE, yd->session_id);
+	/* fd == NULL && error == 0 means connect was cancelled */
+	if (!fd)
+		return;
+
+	pkt = yahoo_packet_new(YAHOO_SERVICE_AUTH, YPACKET_STATUS_DEFAULT,
+		yd->session_id);
 	NOTICE(("Sending initial packet"));
 
 	yahoo_packet_hash(pkt, 1, yd->user);
 
-	yid = y_new0(struct yahoo_input_data, 1);
-	yid->yd = yd;
+	yid = find_input_by_id_and_type(yd->client_id, YAHOO_CONNECTION_PAGER);
 	yid->fd = fd;
-	inputs = y_list_prepend(inputs, yid);
 
 	yahoo_send_packet(yid, pkt, 0);
@@ -3998,40 +3562,13 @@
 	yahoo_packet_free(pkt);
 
-	yid->read_tag = YAHOO_CALLBACK(ext_yahoo_add_handler) (yid->yd->client_id, yid->fd, YAHOO_INPUT_READ, yid);
-}
-
-void yahoo_login(int id, int initial)
-{
-	struct yahoo_data *yd = find_conn_by_id(id);
-	struct connect_callback_data *ccd;
-	struct yahoo_server_settings *yss;
-	int tag;
-
-	if (!yd)
-		return;
-
-	yss = yd->server_settings;
-
-	yd->initial_status = initial;
-
-	ccd = y_new0(struct connect_callback_data, 1);
-	ccd->yd = yd;
-	tag = YAHOO_CALLBACK(ext_yahoo_connect_async) (yd->client_id, yss->pager_host, yss->pager_port, 
-			yahoo_connected, ccd);
-
-	/*
-	 * if tag <= 0, then callback has already been called
-	 * so ccd will have been freed
-	 */
-	if (tag > 0)
-		ccd->tag = tag;
-	else if (tag < 0)
-		YAHOO_CALLBACK(ext_yahoo_login_response) (yd->client_id, YAHOO_LOGIN_SOCK, NULL);
-}
-
-
-int yahoo_get_fd(int id)
-{
-	struct yahoo_input_data *yid = find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
+	yid->read_tag =
+		YAHOO_CALLBACK(ext_yahoo_add_handler) (yid->yd->client_id,
+		yid->fd, YAHOO_INPUT_READ, yid);
+}
+
+void *yahoo_get_fd(int id)
+{
+	struct yahoo_input_data *yid =
+		find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
 	if (!yid)
 		return 0;
@@ -4040,7 +3577,14 @@
 }
 
-void yahoo_send_im(int id, const char *from, const char *who, const char *what, int utf8, int picture)
-{
-	struct yahoo_input_data *yid = find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
+void yahoo_send_buzz(int id, const char *from, const char *who)
+{
+	yahoo_send_im(id, from, who, "<ding>", 1, 0);
+}
+
+void yahoo_send_im(int id, const char *from, const char *who, const char *what,
+	int utf8, int picture)
+{
+	struct yahoo_input_data *yid =
+		find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
 	struct yahoo_packet *pkt = NULL;
 	struct yahoo_data *yd;
@@ -4052,11 +3596,12 @@
 	yd = yid->yd;
 
-	pkt = yahoo_packet_new(YAHOO_SERVICE_MESSAGE, YAHOO_STATUS_OFFLINE, yd->session_id);
+	pkt = yahoo_packet_new(YAHOO_SERVICE_MESSAGE, YAHOO_STATUS_OFFLINE,
+		yd->session_id);
 
 	snprintf(pic_str, sizeof(pic_str), "%d", picture);
-	
+
 	if (from && strcmp(from, yd->user))
 		yahoo_packet_hash(pkt, 0, yd->user);
-	yahoo_packet_hash(pkt, 1, from?from:yd->user);
+	yahoo_packet_hash(pkt, 1, from ? from : yd->user);
 	yahoo_packet_hash(pkt, 5, who);
 	yahoo_packet_hash(pkt, 14, what);
@@ -4069,5 +3614,4 @@
 	yahoo_packet_hash(pkt, 206, pic_str);
 
-
 	yahoo_send_packet(yid, pkt, 0);
 
@@ -4077,5 +3621,6 @@
 void yahoo_send_typing(int id, const char *from, const char *who, int typ)
 {
-	struct yahoo_input_data *yid = find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
+	struct yahoo_input_data *yid =
+		find_input_by_id_and_type(id, YAHOO_CONNECTION_PAGER);
 	struct yahoo_data *yd;
 	struct yahoo_packet *pkt = NULL;
@@ -4084,8 +3629,9 @@
 
 	yd = yid->yd;
-	pkt = yahoo_packet_new(YAHOO_SERVICE_NOTIFY, YAHOO_STATUS_NOTIFY, yd->session_id);
+	pkt = yahoo_packet_new(YAHOO_SERVICE_NOTIFY, YPACKET_STATUS_NOTIFY,
+		yd->session_id);
 
 	yahoo_packet_hash(pkt, 5, who);
-	yahoo_packet_hash(pkt, 1, from?from:yd->user);
+	yahoo_packet_hash(pkt, 1, from ? from : yd->user);
 	yahoo_packet_hash(pkt, 14, " ");
 	yahoo_packet_hash(pkt, 13, typ ? "1" : "0");
